tic;


g=0;                              %no. of genes without replications
Nsim =200;                         % no. of simulation
GG1 = [2000];                    % no. of genes with replication
I1 = [3];                       % no. of repeated observations for each gene
J1 = [4];                        % no. of arrays
const=2/pi;

load Seed.mat

rand('state',Seed_u);
randn('state',Seed_n);


for k=1:Nsim;
    
    disp('nsim'); disp(k); 
              
    for j = 1:size(I1, 2);
        
        for i = 1:size(GG1, 2); 
            
            for l=1:size(J1,2);
             
                G = GG1(i);
                I = I1(j);
                J = J1(l);
        
                nn=G/10;
                cv_sample=zeros(1,nn);
                cv_sample=randsample(G,nn);               %randomly select 10 percent pairs for cross validation
        
                cv=sort([cv_sample*3-2; cv_sample*3-1;cv_sample*3]);               
        
                %now the cv is the ordered locations of the cross-validation sample in the
                %replicated genes
                for jj=1:J-1;
                    cv=[cv; sort([cv_sample*3-2+jj*(G*I+g); cv_sample*3-1+jj*(G*I+g);cv_sample*3+jj*(G*I+g)])];
                end;

        
                % generating the data
                [Z, X, Y, alpha, beta, f, Z_r, X_r, Y_r, alpha_r, f_r,sigma, sigma_r] = gendata(G, g, I, J);
       
                Z_o=Z;              %save a copoy
                X_o=X;
                alpha_o=alpha;
                f_o=f;
                Y_o=Y;
                      
                chi_low(k,1:J)=0;
                abs_low(k,1:J)=0;
      
                G1=G-nn;                        %G1=2000-200=1800
                Z=Z_r;                          %use replicated spots to estimate the parameters
                X=X_r;
                f=f_r;
                Y=Y_r;
                sigma=sigma_r;
        
        
                Z(cv,:)=[];                      %let the "cv" spots to be null Z is a matrix and the rest are column vector
                X(cv)=[];
                f(cv)=[];
                Y(cv)=[];
                sigma(cv)=[];
         
%%%%%%%%%%%%%%%%%%%%%%%%%%%% LOWESS Normalization %%%%%%%%%%%%%%%%%%%%%%%    
        
        
                % initial values for beta and function f
                f1_hat = zeros(G1*I+g, J);                  %estimated values
       
                alpha1_hat = zeros(G1+g, 1);
   
                alpha1_hat = step1(Y, G1, g, I, J);
                alpha1a_hat = reshape(ones(I, 1)*(alpha1_hat(1:G1))', G1*I, 1);
                alpha1a_hat = [alpha1a_hat' (alpha1_hat(G1+1:G1+g))']';
                alpha1a_hat =  reshape((alpha1a_hat(1:G1*I+g))*ones(1,J), J*(I*G1+g), 1);
           
                        % replicate 'alpha_hat' I times
             
                Y_temp = Y - alpha1a_hat ;
                for j1=1:J
                  if j1==1
                     f1_hat = ebbsmv01(X((I*G1+g)*(j1-1)+1:(I*G1+g)*j1), Y_temp((I*G1+g)*(j1-1)+1:(I*G1+g)*j1));
                  else 
                     temp = ebbsmv01(X((I*G1+g)*(j1-1)+1:(I*G1+g)*j1), Y_temp((I*G1+g)*(j1-1)+1:(I*G1+g)*j1));
                     f1_hat = [f1_hat; temp];
                end;
            end; 
            
           
        f1_hat = interp1(X,f1_hat,X_o,'linear','extrap');        %estimate the intensity effect for the whole data set
        
        Z=Z_r;
        X=X_r;
        f=f_r;
        Y=Y_r;
        sigma=sigma_r;              %here the variance is known
                
        Y_temp1 = Y - reshape(f1_hat, (G*I+g)*J,1);                %lowess method
        
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Validation test%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            tmp=Y_temp1(cv);             %validation test
            
            tmp5=remlvar(tmp,I,nn,J);               %REML estimator
                   
            [chi_low(k,:),abs_low(k,:)]=validation2(tmp,I,nn,J,tmp5,sqrt(tmp5));       %the REML sigma 
            

	end;
    end;
    end;
    
   save CV_Resultlow.mat chi_low abs_low;
end;

toc;
