function [svar,row]=remlvar(x,I,n,J);             

%return the REML estimator of Variance

%input is a column vector of I*n*J rows, with I replicated spots together. 
%Total pairs is n, on J arrays. return sd is n*J matrix

x1=reshape(x,I*n,J);
x2=zeros(n,J);              
x4=zeros(n,J);
sd=zeros(n,J);
for j=1:J;
    x3=reshape(x1(:,j),I,n);
    x2(:,j)=mean(x3,1)';        %smaple mean on the jth array
    temp=ones(3,1);
    x4(:,j)=sum((x3-temp*mean(x3,1)).^2,1)';   %sum of squared residuals
end;

x5=sum(x4,2)/(I-1)/J;         %s_{W,g}^2 in the papaer (n*1)

x_mean=mean(x2,2);            %overal sample mean
x6=sum((x2-x_mean*ones(1,J)).^2,2)*I/(J-1);   %s_{B,g}^2 in the paper (n*1)

theta= log(sum(x6)/sum(x5));  %estimate of theta
row=(exp(theta)-1)/(exp(theta)+I-1);  %estimate of row

x7=((J-1)*x6/(1+(I-1)*row)+j*(I-1)*x5/(1-row))/(I*J-1);    

%REML estimate of variance

svar=x7*ones(1,J);